#include <iostream>
#include <vector>
#include <string>
#include <stdexcept>
#include <iomanip>
#include <math.h>

int Exa(char c) {
  if (c>='0' && c<='9') return c-'0';
  if (c>='a' && c<='f') return c-'a'+10;
  throw runtime_error("Not a valid exadecimal digit");
}

void InsertPtr(vector<unsigned char> &v, int pos, void *ptr) {
  int i;
  unsigned int p;
  p=(unsigned int)(ptr);
  for (i=0;i<4;++i) {
    v[pos+i]=p%256;
    p/=256;
  }
}

vector<unsigned char> LoadAsm(istream &in) {
  string s;
  bool headers=true;
  vector<unsigned char> r;
  while (getline(in,s)) {
    if (!headers) {
      //      cout<<"line: "<<string(s,6)<<"\n";
      int p=r.size();
      for (int i=6;i+3<s.size() && s[i]!=' ';i+=3) {
	unsigned char c;
	c=Exa(s[i])*16+Exa(s[i+1]);
	r.push_back(c);
	//	cout<<s[i]<<s[i+1]<<"\n";
      }
      if (r.size()>=p+5 && r[p]==(unsigned char)(0xe8)) {
	typedef double (*fn)(double);
	InsertPtr(r,p+1,sin);
      }
    }
    if (s.find('<')<s.npos) headers=false;
  }
  return r;
}

void WriteExa(const vector<unsigned char> &v,ostream &out) {
  ostream::fmtflags flags=out.flags();
  for (vector<unsigned char>::const_iterator i=v.begin();i!=v.end();++i) {
    out<<hex<<setw(2)<<setfill('0')<<int(*i)<<" ";
  }
  out<<"\n";
  out.flags(flags);
}

void *AsmAlloc(const vector<unsigned char> &v) {
  unsigned char *ptr;
  ptr=new unsigned char[v.size()];
  unsigned char *j=ptr;
  for (vector<unsigned char>::const_iterator i=v.begin();i!=v.end();++i) {
    *(j++)=*i;
  }
  return ptr;
}

typedef double (*fn)(double,double);

int main() {
  vector<unsigned char> v;
  v=LoadAsm(cin);
  WriteExa(v,cout);
  fn f=fn(AsmAlloc(v));
  cout<<"sin: "<<(void *)(sin)<<"\n";
  cout<<"f(3,4)="<<f(3,4)<<" f(1,3)="<<f(1,3)<<"\n";
}
