#ifndef DRAWING_H
#define DRAWING_H

#include <iostream>
#include <cmath>
#include <map>
#include <vector>
#include <set>

class point {
public:
  double x;
  double y;
  point(){};
  point(double xx,double yy): x(xx), y(yy) {};
  point(const point &p): x(p.x), y(p.y) {};
};

class drawer {
protected:
  point lower_left;
  point upper_right; // coordinate degli estremi del foglio
public:
  drawer(point ll, point ur): lower_left(ll), upper_right(ur){};
  virtual ~drawer(){};
  void window(point ll, point ur) {lower_left=ll;upper_right=ur;};
  double x0() const {return lower_left.x;};
  double x1() const {return upper_right.x;};
  double y0() const {return lower_left.y;};
  double y1() const {return upper_right.y;};
  double width() const {return x1()-x0();};
  double height() const {return y1()-y0();};
  
  virtual void setlinewidth(double w){};
  virtual void graph(const map<double,double> &g);
  virtual void curve(const vector<point> &c);
  virtual void line(point from, point to)=0;
};

#endif //DRAWING_H
