#include <iostream>

#include "algebra.h"
#include "parser.h"
#include "ruleset.h"

void my_simplify(Expr &x) {
  cerr<<"("<<x;
  PreRuleset().simplify(x);
  cerr<<" -> "<<x;
  ExpandRuleset().simplify(x);
  cerr<<" -> "<<x;
  StandardRuleset().simplify(x);
  cerr<<" -> "<<x<<")\n";
}

int main() {
  map<string,Expr> input;
  int line=0;
  while (true) {
    string var;
    {
      char buf[8];
      for (int i=0;i<8;i++) buf[i]=0;
      ostrstream o(buf,8);
      o<<"$"<<line;
      var=buf;
    }
    try {
      cout<<"\n["<<var<<"] ";
      cin>>input[var];
      line++;
      input[var]=input[var].replace(input);
      my_simplify(input[var]);
      input["$"]=input[var];
      cout<<"{"<<var<<"} "<<input[var]<<"\n";
      if (input[var].constant()) {
	cout<<"~ "<<input[var].eval()<<"\n";
      }
    } catch (runtime_error e) {
      cerr<<"Runtime error: "<<e.what()<<"\n";
    }
  }
}

