#ifndef __RULESET_H_
#define __RULESET_H_

#include "algebra.h"

#ifdef USE_NAMESPACE
namespace Algebra {
#endif
#if 0
}
#endif

static inline void pushr(Ruleset &r,const Expr &x,const Expr &y) {
  r.push_back(new Rule(x,y));
}

static inline void pushs(Ruleset &r,const Expr &x,const Expr &y) {
  r.push_back(new SimplifyRule(x,y));
}

// toglie tutti i '-' e '/'
Ruleset &PreRuleset() {
  static Ruleset r;
  static bool first=true;
  if (first) {
    first=false;
    Expr x("X"), y("Y"), z("Z"), w("W");
    pushr(r,x-y,x+Expr(-1)*y);
    pushr(r,-x,Expr(-1)*x);
    pushr(r,x/y,x*pow(y,Expr(-1)));
  }
  return r;
}

Ruleset &StandardRuleset() {
  static Ruleset r;
  static bool first=true;
  if (first) {
    first=false;
    Expr x("X"), y("Y"), z("Z"), w("W");

    pushr(r,x+x,2*x);
    pushr(r,z+x+x,z+2*x);
    pushr(r,x*x,pow(x,2));    
    pushr(r,z*x*x,z*pow(x,2));

    pushs(r,x*y+z*y,(x+z)*y);    
    pushs(r,x+y*x,(1+y)*x);
    pushs(r,x*y*z+w*y*z,(x+w)*y*z);
  }
  return r;
};

Ruleset &ExpandRuleset() {
  static Ruleset r;
  static bool first=true;
  if (first) {
    first=false;
    Expr x("X"), y("Y"), z("Z"), w("W");
    pushr(r,x*(y+z),x*y+x*z);
    pushr(r,(x+y)*z,x*z+y*z);
  }
  return r;
};


#if 0
{
#endif
#ifdef USE_NAMESPACE
}
#endif

#endif
