#include <iostream>
#include <cstdlib>
#include "algebra.h"
#include "statusbar.h"

bool ok=true;

int big=10000;

int depth=100;

void check() {
  static int magic=-1;
  if (magic==-1) magic=Expr::count;
  else if (magic!=Expr::count) {
    cout<<"Mismatch! "<<magic<<" != "<<Expr::count<<"\n";
    ok=false;
  }
}

Expr create(int depth) {
  if (depth<1) {
    switch(random()%5) {
    case 0:
      return Expr(double(random()));
    case 1:
      return Expr(random()%100);
    case 2:
      {
	char s[2];
	s[1]=0;
	s[0]='a'+random()%5;
	return Expr(string(s));
      }
    case 3:
      return Expr();
    case 4:
      return Expr(1);
    default:
      ;
    } 
  } else {
      switch(random()%9) {
      case 0:
      case 1:
	return create(random()%depth) * create(random()%depth);
      case 2:
      case 3:
	return create(random()%depth) + create(random()%depth);
      case 4:
	return create(random()%depth) / create(random()%depth);
      case 5:
	return create(random()%depth) / create(random()%depth);
      case 6:
	return pow(create(random()%depth),create(random()%depth/2));
      case 7:
	return -create(random()%depth);
      case 8: 
	return sin(create(random()%depth));
      default:
	;
      }
  }
  return Expr(0);
};

void creation_test() {
  cout<<"creation test...\n";
  {
    StatusBar bar(big);
    for (int i=0;i<big;++i) {
      Expr x=create(depth);
      bar.next();
    }
  }
  cout<<"ok\n";
}

void visualization_test() {
  cout<<"visualization test...\n";
  for (int i=0;i<20;i+=2) {
    cout<<create(i)<<"\n";
  }
  cout<<"ok\n";
}

void assignment_test() {
  cout<<"assignment test...\n";
  {
    StatusBar bar(2*big);
    const int n=big;
    Expr v[n];
    for (int i=0;i<big;++i) {
      v[random()%n]=create(depth);
      bar.next();
    }
    for (int i=0;i<big;++i) {
      v[random()%n]=v[random()%n];
      bar.next();
    }
  }
  cout<<"ok\n";
}

void simplify_test() {
  cout<<"simplify test...\n";
  {
    StatusBar bar(big);
    for (int i=0;i<big;++i) {
      Expr x=create(depth);
      x.simplify();
      bar.next();
    }
  }
  cout<<"ok\n";
}

int main(int argc, char *argv[]) {
  int seed=0;
  if (argc>1) {
    for (int i=0;argv[1][i];++i)
      seed=seed^argv[1][i];
  }
  cout<<"seed: "<<seed<<"\n";
  srandom(seed);
  check();
  {Expr x; x=x;}check();
  //  creation_test();check();
  //  visualization_test();check();
  assignment_test();check();
  simplify_test();check();
};
