#ifndef _PNGDRAWING_H_
#define _PNGDRAWING_H_

#include "drawing.h"
#include <gd.h>

class pngdrawer: public drawer {
  FILE *o;
  int w,h;
  gdImagePtr im;
  int back,fore;
  int realx(const point &p) const {
    return int((p.x-lower_left.x)/(upper_right.x-lower_left.x)*w);
  }
  int realy(const point &p) const {
    return h-int((p.y-lower_left.y)/(upper_right.y-lower_left.y)*h);
  }
 public:
  pngdrawer(FILE *out,int width,int height): 
    drawer(point(0,0),point(width,height)),
    o(out), w(width), h(height) {
    im=gdImageCreate(width,height);
    back=gdImageColorAllocate(im,255,255,255); //white background
    fore=gdImageColorAllocate(im,0,0,0); //black pen
    };
  ~pngdrawer() {
    if (o) {
      gdImagePng(im,o);
    }
    gdImageDestroy(im);
  };
  virtual void line(point from, point to) {
    gdImageLine(im,realx(from),realy(from),realx(to),realy(to),fore);};
};

#endif
